import json, os, re, copy
from multiprocessing import Pool



def run_one_design(bench, design_name):

    print(bench, design_name)
    reg_lst_path = f"/home/coguest5/hdl_fusion/data_collectvlg/data/reg_lst/{design_name}.json"
    with open(reg_lst_path, 'r') as f:
        reg_lst = json.load(f)
    
    
    reg_set = set(reg_lst)
    reg_set_new = set()

    text_path = f"/home/coguest5/hdl_fusion/data_collecttext/data/text/{design_name}"
    if not os.path.exists(text_path):
        return
    reg_lst_new = os.listdir(text_path)

    for r in reg_lst_new:
        reg_set_new.add(r.split(".")[0])
    
    # print(reg_set_new)

    ll = round(len(reg_set_new)/len(reg_set)*100,1)
    
    global num, num_ep, num0
    if ll > 80:
        print(f" percent: {ll}%")
        num +=1
        num_ep += len(reg_set_new)

        reg_set_final = reg_set_new & reg_set
        # print(reg_set_final)

        design_lst.append(design_name)

        return

        design_dict = {}
        design_dict[design_name] = list(reg_set_final)
        with open(f"../json/{design_name}.json", 'w') as f:
            json.dump(design_dict, f)
        
        if not os.path.exists(f"../ori/text/{design_name}"):
            os.makedirs(f"../ori/text/{design_name}")
        if not os.path.exists(f"../ori/vlg/{design_name}"):
            os.makedirs(f"../ori/vlg/{design_name}")
        if not os.path.exists(f"../ori/graph/{design_name}"):
            os.makedirs(f"../ori/graph/{design_name}")

        for r in reg_set_final:
            os.system(f"ln -s /home/coguest5/hdl_fusion/data_collecttext/data/text/{design_name}/{r}.txt ../ori/text/{design_name}/{r}.txt")
            os.system(f"ln -s /home/coguest5/hdl_fusion/data_collectvlg/data/ep_vlg/{design_name}/{r}.v ../ori/vlg/{design_name}/{r}.v")
            # os.system(f"cp /home/coguest5/hdl_fusion/data_collectgraph/data/graph/{design_name}/{r}.json ../ori/graph/{design_name}/{r}.json")


    else:
        num0 +=1



if __name__ == '__main__':
    bench_dict = {}
    design_json = "/home/coguest5/rtl_repr/LS-benchmark/design_rtl_repr.json"
    bench_list = ['itc','opencores','VexRiscv','chipyard', 'riscvcores','NVDLA']


    global num, num_ep, num0
    num = 0
    num_ep = 0
    num0 = 0

    global design_lst
    design_lst = []

    design_name = 'spi'

    design_name = ""

    for bench in bench_list:
        with open(design_json, 'r') as f:
            design_data = json.load(f)
            dir_ = design_data[bench]
            for k, v in dir_.items():
                if design_name:
                    if k == design_name:
                        run_one_design(bench, design_name)
                else:
                    run_one_design(bench, k)


    print(num)
    print(num_ep)
    print(num0)

    with open("../json/design_lst/design_lst.json", 'w') as f:
        json.dump(design_lst, f)