import torch
import numpy as np
import pickle, json, time, re, sys, os
import networkx as nx
from multiprocessing import Pool
import dgl
from dgl import from_networkx
import dgl
from torch import Tensor
import torch.nn.functional as F
from transformers import AutoTokenizer, AutoModel
from sentence_transformers import SentenceTransformer

os.environ["CUDA_VISIBLE_DEVICES"] = "0,1"
from accelerate import Accelerator



def get_dataset(design_lst):

    for design in design_lst:
        print("Current design: ", design)
        with open (f"/home/coguest5/hdl_fusion/data_collect/label/ep_lst/{design}.json", 'r') as f:
            reg_lst = json.load(f)
        save_dir = f"../rtl_emb/{cmd}/{design}"

        final_save_dir = f"../rtl_emb/final/{design}"
        if not os.path.exists(final_save_dir):
            os.makedirs(final_save_dir)

        for ep in reg_lst:
            
            

            with open(f"{save_dir}/{ep}.pkl", 'rb') as f:
                (batch_dict, outputs, embeddings) = pickle.load(f)

            with open(f"{final_save_dir}/{ep}_batch_dict.pkl", 'wb') as f:
                pickle.dump(batch_dict, f)
            with open(f"{final_save_dir}/{ep}_outputs.pkl", 'wb') as f:
                pickle.dump(outputs, f)
            with open(f"{final_save_dir}/{ep}_embeddings.pkl", 'wb') as f:
                pickle.dump(embeddings, f)
            os.system(f"du -sh {final_save_dir}/{ep}_batch_dict.pkl")
            os.system(f"du -sh {final_save_dir}/{ep}_outputs.pkl")
            os.system(f"du -sh {final_save_dir}/{ep}_embeddings.pkl")
            
            exit()



if __name__ == '__main__':

    global design_lst_all, cmd
    cmd = "ori"
    cmd = "pos"
    with open("/home/coguest5/hdl_fusion/dataset/dataset_js/design_all.json", 'r') as f:
        design_lst_all = json.load(f)
    
    get_dataset(design_lst_all)